---
title: Response.type
slug: Web/API/Response/type
tags:
  - API
  - Experimental
  - Fetch
  - Property
  - Reference
  - Response
  - Type
---
<div>{{APIRef("Fetch")}}</div>

<p>The <strong><code>type</code></strong> read-only property of the {{domxref("Response")}} interface contains the type of the response. It can be one of the following:</p>

<ul>
 <li><code>basic</code>: Normal, same origin response, with all headers exposed except “Set-Cookie” and “Set-Cookie2″.</li>
 <li><code>cors</code>: Response was received from a valid cross-origin request. <a href="https://fetch.spec.whatwg.org/#concept-filtered-response-cors">Certain headers and the body</a> may be accessed.</li>
 <li><code>error</code>: Network error. No useful information describing the error is available. The Response’s status is 0, headers are empty and immutable. This is the type for a Response obtained from <code>Response.error()</code>.</li>
 <li><code>opaque</code>: Response for “no-cors” request to cross-origin resource. <a href="https://fetch.spec.whatwg.org/#concept-filtered-response-opaque">Severely restricted</a>.</li>
 <li><code>opaqueredirect</code>: The fetch request was made with <code>redirect: "manual"</code>. The Response's status is 0, headers are empty, body is null and trailer is empty.</li>
</ul>

<div class="note">
<p><strong>Note</strong>: An "error" Response never really gets exposed to script: such a response to a {{domxref("GlobalFetch.fetch","fetch()")}} would reject the promise.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js">var myType = response.type;</pre>

<h3 id="Value">Value</h3>

<p>A <code>ResponseType</code> string indicating the type of the response.</p>

<h2 id="Example">Example</h2>

<p>In our <a href="https://github.com/mdn/fetch-examples/tree/gh-pages/fetch-response">Fetch Response example</a> (see <a href="https://mdn.github.io/fetch-examples/fetch-response/">Fetch Response live</a>) we create a new {{domxref("Request")}} object using the {{domxref("Request.Request","Request()")}} constructor, passing it a JPG path. We then fetch this request using {{domxref("GlobalFetch.fetch","fetch()")}}, extract a blob from the response using {{domxref("Body.blob")}}, create an object URL out of it using {{domxref("URL.createObjectURL")}}, and display this in an {{htmlelement("img")}}.</p>

<p>Note that at the top of the <code>fetch()</code> block we log the response <code>type</code> to the console.</p>

<pre class="brush: js">var myImage = document.querySelector('img');

var myRequest = new Request('flowers.jpg');

fetch(myRequest).then(function(response) {
  console.log(response.type); // returns basic by default
  response.blob().then(function(myBlob) {
    var objectURL = URL.createObjectURL(myBlob);
    myImage.src = objectURL;
  });
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Fetch", "#dom-response-type", "type")}}</td>
   <td>{{Spec2("Fetch")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Response.type")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API">ServiceWorker API</a></li>
 <li><a href="/en-US/docs/Web/HTTP/Access_control_CORS">HTTP access control (CORS)</a></li>
 <li><a href="/en-US/docs/Web/HTTP">HTTP</a></li>
</ul>
